dnl 
dnl C++ name space
dnl
AC_DEFUN(AM_CXX_NAMESPACE, [
  AC_REQUIRE([AC_PROG_CXX_WORKS])
  AC_MSG_CHECKING(${CXX-c++} supports name space)
  AC_CACHE_VAL(am_cv_prog_cxx_work_namespace,
    [
      am_cv_prog_cxx_work_namespace=no
      AC_LANG_SAVE
      AC_LANG_CPLUSPLUS
      AC_TRY_COMPILE(
        [
          namespace nspace {
            class parent {
            public:
              int member;
            };
          }
          class child : public nspace::parent {
          };
        ],[
          child a; 
          a.member = 1;  
        ],
        am_cv_prog_cxx_work_namespace=yes,
        am_cv_prog_cxx_work_namespace=no
      )
      AC_LANG_RESTORE
    ]
  )
  if test "$am_cv_prog_cxx_work_namespace" = "yes"; then
    AC_MSG_RESULT($am_cv_prog_cxx_work_namespace)
    AC_DEFINE(WORK_NAMESPACE)
  else
    AC_MSG_RESULT($am_cv_prog_cxx_work_namespace)
  fi
])
AC_DEFUN(CHECK_STL_SGI,
[
    AC_MSG_CHECKING([if STL implementation is SGI like])
    AC_CACHE_VAL(kde_cv_stl_type_sgi,
    [
      AC_LANG_CPLUSPLUS
      AC_TRY_COMPILE([
#include <string>
],[
  string astring="Hallo Welt.";
  astring.erase(0, 6); // now astring is "Welt"
  return 0;
], kde_cv_stl_type_sgi=yes,
   kde_cv_stl_type_sgi=no)
])

   AC_MSG_RESULT($kde_cv_stl_type_sgi)

   if test "$kde_cv_stl_type_sgi" = "yes"; then
	AC_DEFINE_UNQUOTED(HAVE_SGI_STL) 
   fi
])
AC_DEFUN(CHECK_STL,
[
    AC_REQUIRE([AC_PROG_CXX_WORKS])
    CHECK_STL_SGI
    
    if test "$kde_cv_stl_type_sgi" = "no"; then
        AC_MSG_ERROR("You don\'t have STL or STL implementation isn\'t SGI like")
    fi

])
AC_DEFUN(PTHREAD_CONFIG, [
    dnl
    dnl check for POSIX thread library
    dnl
    AC_ARG_ENABLE(pthread,
        [  --enable-pthread 	  enable POSIX thread code(but now broken)],
        ac_use_pthread_code="yes", ac_use_pthread_code="no")
    AC_ARG_WITH(pthread-includes,
        [  --with-pthread-includes=DIR    POSIX thread include files are in DIR],
        PTHREAD_INCLUDES=$withval, PTHREAD_INCLUDES=$includedir)

    AC_ARG_WITH(pthread-libraries,
        [  --with-pthread-libraries=DIR   POSIX thread files are in DIR],
        PTHREAD_LIBRARIES=$withval, PTHREAD_LIBRARIES=$libdir)
    PTHREAD_INCLUDES="-I$PTHREAD_INCLUDES"
    LIB_PTHREAD="-L$PTHREAD_LIBRARIES -lpthread"
])
AC_DEFUN(CHECK_LIBPTHREAD,
[
    AC_REQUIRE([PTHREAD_CONFIG])
    ac_lib_pthread="no"
    if test "$ac_use_pthread_code" = "yes"; then 
        AC_CHECK_LIB(pthread, pthread_create,
            ac_lib_pthread="yes",
            ac_lib_pthread="no")
    fi
    if test "$ac_lib_pthread" = "no"; then
        LIB_PTHREAD=""
    else
        PTHREAD_FLAGS="-D_REENTRANT"
    fi
    AC_SUBST(LIB_PTHREAD)
])
AC_DEFUN(CHECK_PTHREAD, [
    AC_REQUIRE([CHECK_LIBPTHREAD])
    if test "$ac_use_pthread_code" = "yes"; then
        AC_MSG_CHECKING([for pthread])
        if test "$ac_lib_pthread" = "no"; then
            PTHREAD_FLAGS="-pthread -D_THREAD_SAFE"
        fi
        ac_save_CC="$CC"
        CC="$CC $PTHREAD_FLAGS $PTHREAD_INCLUDES"
        ac_save_LIBS="$LIBS"
        LIBS="$LIBS $LIB_PTHREAD"
        AC_LANG_SAVE
        AC_LANG_C
        AC_TRY_LINK([
#include <pthread.h>
],[
  pthread_self();
],
            ac_pthread_ok=yes,
            ac_pthread_ok=no)
        AC_LANG_RESTORE
        CC="$ac_save_CC"
        LIBS="$ac_save_LIBS"
        if test "$ac_pthread_ok"="yes"; then
            AC_DEFINE(HAVE_PTHREAD)
            AC_MSG_RESULT("$ac_pthread_ok")
        else
            AC_MSG_RESULT("$ac_pthread_ok")
            AC_MSG_ERROR(*** pthread library not found ***)
        fi
    else
        AC_MSG_RESULT("no")
        PTHREAD_FLAGS=""
        PTHREAD_INCLUDES=""
    fi 
    AC_SUBST(PTHREAD_FLAGS)
    AC_SUBST(PTHREAD_INCLUDES)
])
