/*
 * $Id: constants.h,v 1.2 2001/01/13 19:46:35 hige Exp $
 *
 * Copyright (C) 1999 SUZUKI, Mitsuhiro <hige@higesoft.rim.or.jp>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */
#ifndef CONSTANTS_H
#define CONSTANTS_H
#include <sys/types.h>

// General purpose
#define EMPTY       0

//
// ID of GUI Parts
//

// ToolBar Button
enum {
    ID_TBBTN_EXIT,
    ID_TBBTN_BACK,
    ID_TBBTN_FORWARD,
    ID_TBBTN_OPENDIR,
    ID_TBBTN_SETSUBBOOK,
    ID_TBBTN_STOPLOOKINGUP,
    ID_TBBTN_MENU,
    ID_TBBTN_COPYRIGHT,
    ID_TBBTN_WAY_TO_SEARCH,
    ID_TBBTN
};
// Main Menu
enum {
    ID_MENU_FILE            = 1010,
    ID_MENU_OPTION          = 1011,
    ID_MENU_SHOW            = 1012,
    ID_MENU_GO              = 1013,
    ID_MENU_CDROM           = 1014,
    ID_MENU_HELP            = 1015,
    ID_MENU_EDIT            = 1016,
    ID_MENU                 = 1017
};
// Menu Item
enum {
    ID_MENUITEM_QUIT                    = 1020,
    ID_MENUITEM_FIND                    = 1032,
    ID_MENUITEM_FINDNEXT                = 1033,
    ID_MENUITEM_OPEN_SELECT_WAY         = 1021,
    ID_MENUITEM_OPEN_SELECT_DICT_DLG    = 1022,
    ID_MENUITEM_OPEN_SET_DIR_DLG        = 1023,
    ID_MENUITEM_OPEN_EDIT_ACCEL_DLG     = 1024,
    ID_MENUITEM_BACK                    = 1025,
    ID_MENUITEM_FORWARD                 = 1026,
    ID_MENUITEM_DICT_MENU               = 1027,
    ID_MENUITEM_COPYRIGHT               = 1028,
    ID_MENUITEM_SELECT_FORWARD_MATCH    = 1029,
    ID_MENUITEM_SELECT_EXACT_MATCH      = 1030,
    ID_MENUITEM_SELECT_BACKWARD_MATCH   = 1031,
    ID_MENUITEM_RESCAN_DICTIONARIES     = 1032,
    ID_MENUITEM_OPEN_COLOR_DLG          = 1033
};
// StatusBar Parts
enum {
    IDS_LOOKINGUP_PROGRESSIVE = 100,
    IDS_STATUS_MESSAGE = 101
};

//
// Default 
//
typedef const char* const CONST_STR;

#define         DEFAULT_DICT_PATH           (QDir::currentDirPath())
CONST_STR       DEFAULT_TEMP_PATH           = "/tmp";
const int       DEFAULT_PREV_SUBBOOK        = -1;
CONST_STR       DEFAULT_PREV_SUBBOOK_DIR    = "";

//
// Config File Entry
//
CONST_STR     CFG_GENERAL_GROUP           = "General";
CONST_STR     CFG_HISTORY_SIZE_ENTRY      = "HistorySize";
CONST_STR     CFG_WAY_TO_SEARCH           = "SearchWay";
CONST_STR     CFG_SUBBOOK_PREVNUM_ENTRY   = "PrevSubbookNum";
CONST_STR     CFG_SUBBOOK_PREVDIR_ENTRY   = "PrevSubbookDir";
CONST_STR     CFG_PATH_GROUP              = "Path";
CONST_STR     CFG_DICT_PATH_ENTRY         = "DictPath";
CONST_STR     CFG_FONT_PATH_ENTRY         = "FontPath";
CONST_STR     CFG_GEOMETRY_GROUP          = "Geometry";
CONST_STR     CFG_MAIN_WINDOW_ENTRY       = "MainWindow";
CONST_STR     CFG_RESULTPART_GROUP        = "ResultPart";
CONST_STR     CFG_BACKGROUNDCOLOR_ENTRY   = "BackgroundColor";
CONST_STR     CFG_TEXTCOLOR_ENTRY         = "TextColor";
CONST_STR     CFG_LINKCOLOR_ENTRY         = "LinkColor";
CONST_STR     CFG_DICTDIR_HISTORY_ENTRY   = "DictionaryDirectoryHistory";

//
// Font File and Directory infomation
//
const int       ERR                     = -1;
const mode_t    TEMP_MODE               = 0700;
CONST_STR       TEMP_TEMPLATE           = PACKAGE "-%05lx";
CONST_STR       FONTS_ROUTE_DIR         = "fonts";
CONST_STR       NARROW_FONTS_DIR        = "narrow";
CONST_STR       WIDE_FONTS_DIR          = "wide";

//
// Bitmap File
//
CONST_STR       BACK_TBBTN_PIXMAP           = "back";
CONST_STR       FORWARD_TBBTN_PIXMAP        = "forward";
CONST_STR       STOP_TBBTN_PIXMAP           = "stop";
CONST_STR       MENU_TBBTN_PIXMAP           = "menu_btn";
CONST_STR       COPYRIGHT_TBBTN_PIXMAP      = "copyright_btn";
CONST_STR       OPENDIR_TBBTN_PIXMAP        = "fileopen";
CONST_STR       SETSUBBOOK_TBBTN_PIXMAP     = "dictionaries";
CONST_STR       WAY_TO_SEARCH_TBBTN_PIXMAP  = "config-search";
CONST_STR       MATCH_FORWARD_TBBTN_PIXMAP  = "match-head";
CONST_STR       MATCH_EXACT_TBBTN_PIXMAP    = "match-exactly";
CONST_STR       MATCH_BACKWARD_TBBTN_PIXMAP = "match-tail";
CONST_STR       EXIT_TBBTN_PIXMAP           = "exit";
CONST_STR       RELOAD_TBBTN_PIXMAP         = "reload";
CONST_STR       DICTIONARIES_TBBTN_PIXMAP   = "dictionaries";
CONST_STR       KEYBOARD_TBBTN_PIXMAP       = "keyboard";


const QEvent::Type  Event_LookupFinish      = (QEvent::Type)(QEvent::User+1);
const QEvent::Type  Event_Progress          = (QEvent::Type)(QEvent::User+2);
//
// Location of file containing list of mounted file systems (mtab)
// Identifier of ISO9660-format CD-ROM file system in mtab
//
CONST_STR       FILE_MTAB                   = "/etc/mtab";
CONST_STR       VFS_ISO9660                 = "iso9660";

#endif // CONSTANTS_H
