/*
 * $Id: findworddlg.h,v 1.2 2000/06/19 06:32:09 hige Exp $
 *
 * Copyright (C) 1999 SUZUKI, Mitsuhiro <hige@higesoft.rim.or.jp>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */
#ifndef FINDWORDDLG_H
#define FINDWORDDLG_H

#include <qdialog.h>
#include <qlineedit.h>
#include <qcheckbox.h>


class QPushButton;
class QGroupBox;

class KFindWordDlg : public QDialog
{
    Q_OBJECT

public:
    KFindWordDlg(QWidget *parent = 0, const char *name=0);

    void getText(QString* text) {*text = m_value->text();}

    void setText(QString string) {m_value->setText(string);}

    bool case_sensitive() {return m_sensitive->isChecked();}

    bool find_backward() {return m_backward->isChecked();}

protected:
    void focusInEvent(QFocusEvent *){m_value->setFocus();}

    void resizeEvent(QResizeEvent *ev);

private:
    void doLayout();
private:
    QPushButton* m_ok;
    QPushButton* m_cancel;
    QCheckBox* m_sensitive;
    QCheckBox* m_backward;
    QGroupBox* m_frame;
    QLineEdit* m_value;

signals:
    void sigSearch();
    void sigSearchDone();

public slots:
    void slotDone(){emit sigSearchDone();}
    void slotOk();
};
#endif // FINDWORDDLG_H
