/*
 * $Id: selectwaytosearchdlg.h,v 1.1.1.1 2000/05/25 06:09:58 hige Exp $
 *
 * Copyright (C) 1999 SUZUKI, Mitsuhiro <hige@higesoft.rim.or.jp>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef SELECTWAYTOSEARCH_H
#define SELECTWAYTOSEARCH_H

#include <qdialog.h>
#include "cebook.hpp"

class QRadioButton;
class QButtonGroup;
class QVBoxLayout;
class QHBoxLayout;
class QSize;

class SelectWayToSearchDlg : public QDialog
{
    Q_OBJECT

public:
    SelectWayToSearchDlg(ebook::CEBook::WAY_TO_SEARCH way,
                         QWidget* parent = 0, const char* name = 0);
    ~SelectWayToSearchDlg() {}
    
    ebook::CEBook::WAY_TO_SEARCH getWayToSearch() {return m_way;}

private slots:
    void clickRadioButton(int id);

private:
    void createRadioButtons(QVBoxLayout* mainlayout);
    void createPushButtons(QVBoxLayout* mainlayout);
    
private:
#ifdef WORK_NAMESPACE    
    ebook::CEBook::WAY_TO_SEARCH m_way;
#else
    CEBook::WAY_TO_SEARCH m_way;
#endif
    
    QRadioButton* m_rbtn_exact;
    QRadioButton* m_rbtn_front;
    QRadioButton* m_rbtn_tail;
    
};


#endif // SELECTWAYTOSEARCH_H
